/*! ********************************************
 * EffectorBase.java
 * Copyright 2019 masahiro takamoto (MotChan)
 * Distributed under the MIT license. 
 * see -> sora/license.txt
 ******************************************** */
package sora.graybox.efx;
public abstract class EffectorBase
{
// Instance -----
	protected float _mix     = 0.0f;  // 0.0 ~ 1.0
	protected float _antiMix = 1.0f;  // 0.0 ~ 1.0
	public float getMix(){ return _mix; }
	public void setMix(float val){ _mix = val; _antiMix = 1.0f - _mix; }
	public abstract void applyEffect(float[] outL, float[] outR, int startFrame, int sampleFrames);
	public void resetParameters(){}
	public void clearBuffer(){}
	public void initialize(){}
// Constructor
	protected EffectorBase(){}
}