/*! ********************************************
 * TonePresetFM4.java
 * Copyright 2019 masahiro takamoto (MotChan)
 * Distributed under the MIT license. 
 * see -> sora/license.txt
 ******************************************** */
package sora.graybox.synth;
public class TonePresetFM4
{
// Inastance -----
	public char[] toneName = {' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' '}; // ASCII 16Chars 
	public int key			= 64;   // 0 - 127     *Percussion
	public int pan			= 64;   // 0 - 127     *Percussion
	public int lfoWave		= 0;    // 0 - 3
	public int lfoFreq		= 2048; // 0 - 16383   LFO - Phase Update Timer Parameter
	public int fl			= 127;  // 0 - 127     Feed Back Level
	public int strc			= 0;    // 0 - 7	    strcture
	// operator 0
	//public int velCurve_0;
	public int tlVelCtrl_0	= 0;   // 0 - 7        Total Level Contorol - Velocity   Senstivity
	public int mul_0		= 1;   // 0 - 15        Multiple       [0] = 1/2 Cycle, [1] = 1/1, [2] = 2/1, [3] = 3/1...
	public int tune_0		= 8192;// 0 - 16383    center 8192, octave = 8192
	public int lms_0		= 0;   // 0 - 15       LFO - Modulation Depth Senstivity
	public int wave_0		= 0;   // 0 - 7
	public int tl_0			= 0;   // 0 - 127
	public int ar_0			= 124; // 0 - 127
	public int dr_0			= 100; // 0 - 127
	public int sl_0			= 0;   // 0 - 127
	public int rr_0			= 120; // 0 - 127
	public int kf_0			= 0;   // 0 - 3        Key Follow Sensitivity         *Instrument 
	public int kfStart_0	= 48;  // 0 - 127      Key Number - Start Key Follow  *Instrument
	// operator 1
	public int tlVelCtrl_1 = 0;
	public int mul_1	 = 1;
	public int tune_1	 = 8192;
	public int lms_1	 = 0;
	public int wave_1	 = 0;
	public int tl_1		 = 0;
	public int ar_1		 = 124;
	public int dr_1		 = 100;
	public int sl_1		 = 0;
	public int rr_1		 = 120;
	public int kf_1		 = 0;
	public int kfStart_1 = 48;
	// operator 2
	public int tlVelCtrl_2 = 0;
	public int mul_2	 = 1;
	public int tune_2	 = 8192;
	public int lms_2	 = 0;
	public int wave_2	 = 0;
	public int tl_2		 = 0;
	public int ar_2		 = 124;
	public int dr_2		 = 100;
	public int sl_2		 = 0;
	public int rr_2		 = 120;
	public int kf_2		 = 0;
	public int kfStart_2 = 48;
	// operator 3
	public int tlVelCtrl_3 = 0;
	public int mul_3	 = 1;
	public int tune_3	 = 8192;
	public int lms_3	 = 0;
	public int wave_3	 = 0;
	public int tl_3		 = 0;
	public int ar_3		 = 124;
	public int dr_3		 = 100;
	public int sl_3		 = 0;
	public int rr_3		 = 120;
	public int kf_3		 = 0;
	public int kfStart_3 = 48;
	
// Method
	public void copy(TonePresetFM4 preset)
	{
		for (int i = 0; i < 16; i++)toneName[i] = preset.toneName[i];
		key = preset.key;
		pan = preset.pan;
		lfoWave = preset.lfoWave;
		lfoFreq = preset.lfoFreq;		
		fl = preset.fl;
		strc = preset.strc;
		// operator 0
		tlVelCtrl_0	= preset.tlVelCtrl_0;
		mul_0		= preset.mul_0;
		tune_0		= preset.tune_0;
		lms_0		= preset.lms_0;
		wave_0		= preset.wave_0;
		tl_0		= preset.tl_0;
		ar_0		= preset.ar_0;
		dr_0		= preset.dr_0;
		sl_0		= preset.sl_0;
		rr_0		= preset.rr_0;
		kf_0		= preset.kf_0;
		kfStart_0	= preset.kfStart_0;
		// operator 1
		tlVelCtrl_1	= preset.tlVelCtrl_1;
		mul_1		= preset.mul_1;
		tune_1		= preset.tune_1;
		lms_1		= preset.lms_1;
		wave_1		= preset.wave_1;
		tl_1		= preset.tl_1;
		ar_1		= preset.ar_1;
		dr_1		= preset.dr_1;
		sl_1		= preset.sl_1;
		rr_1		= preset.rr_1;
		kf_1		= preset.kf_1;
		kfStart_1	= preset.kfStart_1;
		// operator 2
		tlVelCtrl_2	= preset.tlVelCtrl_2;
		mul_2		= preset.mul_2;
		tune_2		= preset.tune_2;
		lms_2		= preset.lms_2;
		wave_2		= preset.wave_2;
		tl_2		= preset.tl_2;
		ar_2		= preset.ar_2;
		dr_2		= preset.dr_2;
		sl_2		= preset.sl_2;
		rr_2		= preset.rr_2;
		kf_2		= preset.kf_2;
		kfStart_2	= preset.kfStart_2;
		// operator 3
		tlVelCtrl_3	= preset.tlVelCtrl_3;
		mul_3		= preset.mul_3;
		tune_3		= preset.tune_3;
		lms_3		= preset.lms_3;
		wave_3		= preset.wave_3;
		tl_3		= preset.tl_3;
		ar_3		= preset.ar_3;
		dr_3		= preset.dr_3;
		sl_3		= preset.sl_3;
		rr_3		= preset.rr_3;
		kf_3		= preset.kf_3;
		kfStart_3	= preset.kfStart_3;
	}
	public void reset()
	{
		for (int i = 0; i < 16; i++)toneName[i] = ' ';
		key = 64;
		pan = 64;
		lfoWave = 0;
		lfoFreq = 2048;
		fl = 127;
		strc = 0;
		// operator 0
		tlVelCtrl_0	= 0;
		mul_0		= 1;
		tune_0		= 8192;
		lms_0 		= 0;
		wave_0		= 0;
		tl_0		= 0;
		ar_0		= 124;
		dr_0		= 100;
		sl_0		= 0;
		rr_0		= 120;
		kf_0		= 0;
		kfStart_0	= 48;
		// operator 1
		tlVelCtrl_1	= 0;
		mul_1		= 1;
		tune_1		= 8192;
		lms_1 		= 0;
		wave_1		= 0;
		tl_1		= 0;
		ar_1		= 124;
		dr_1		= 100;
		sl_1		= 0;
		rr_1		= 120;
		kf_1		= 0;
		kfStart_1	= 48;
		// operator 2
		tlVelCtrl_2	= 0;
		mul_2		= 1;
		tune_2		= 8192;
		lms_2 		= 0;
		wave_2		= 0;
		tl_2		= 0;
		ar_2		= 124;
		dr_2		= 100;
		sl_2		= 0;
		rr_2		= 120;
		kf_2		= 0;
		kfStart_2	= 48;
		// operator 3
		tlVelCtrl_3	= 0;
		mul_3		= 1;
		tune_3		= 8192;
		lms_3 		= 0;
		wave_3		= 0;
		tl_3		= 0;
		ar_3		= 124;
		dr_3		= 100;
		sl_3		= 0;
		rr_3		= 120;
		kf_3		= 0;
		kfStart_3	= 48;
	}
// Constructor
	public TonePresetFM4(){}
}